package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[File] 数据对象
 */
@TableName(value = "T_SRFFILE",resultMap = "FileResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class File extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String digestcode;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    @TableLogic(value= "1",delval="0")//设定逻辑有效属性
    @TableField(fill = FieldFill.INSERT)
    private Integer enable;
    private String filename2;
    private Integer filesize;
    @TableId(value= "file_id",type=IdType.UUID)//指定主键生成策略
    private String fileid;
    @TableField(value= "file_name")
    private String filename;
    private String folder;
    private String localpath;
    private String localpath2;
    private String memo;
    private String ownerid;
    private String ownertype;
    private Integer picheight;
    private Integer picwidth;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[摘要数据]
     *  @param digestcode
     */
    public void setDigestcode(String digestcode){
        if(StringUtils.isEmpty(digestcode))
            digestcode=null;
        this.digestcode = digestcode;
        this.set("digestcodedirtyflag",true);
    }
    /**
     *  获取属性值[摘要数据]
     */
    public String getDigestcode(){
        return this.digestcode;
    }
    /**
     *  重置属性值[摘要数据]
     */
    public void resetDigestcode(){
        this.set("digestcodedirtyflag",false);
        this.digestcode = null;
    }
    /**
     *  设置属性值[逻辑有效标志]
     *  @param enable
     */
    public void setEnable(Integer enable){
        this.enable = enable;
        this.set("enabledirtyflag",true);
    }
    /**
     *  获取属性值[逻辑有效标志]
     */
    public Integer getEnable(){
        if(StringUtils.isEmpty(enable))
        {
            this.enable = 1;//设置逻辑有效值
            this.set("enabledirtyflag",true);
        }
        return this.enable;
    }
    /**
     *  重置属性值[逻辑有效标志]
     */
    public void resetEnable(){
        this.set("enabledirtyflag",false);
        this.enable = null;
    }
    /**
     *  设置属性值[原始文件名称]
     *  @param filename2
     */
    public void setFilename2(String filename2){
        if(StringUtils.isEmpty(filename2))
            filename2=null;
        this.filename2 = filename2;
        this.set("filename2dirtyflag",true);
    }
    /**
     *  获取属性值[原始文件名称]
     */
    public String getFilename2(){
        return this.filename2;
    }
    /**
     *  重置属性值[原始文件名称]
     */
    public void resetFilename2(){
        this.set("filename2dirtyflag",false);
        this.filename2 = null;
    }
    /**
     *  设置属性值[文件大小]
     *  @param filesize
     */
    public void setFilesize(Integer filesize){
        this.filesize = filesize;
        this.set("filesizedirtyflag",true);
    }
    /**
     *  获取属性值[文件大小]
     */
    public Integer getFilesize(){
        return this.filesize;
    }
    /**
     *  重置属性值[文件大小]
     */
    public void resetFilesize(){
        this.set("filesizedirtyflag",false);
        this.filesize = null;
    }
    /**
     *  设置属性值[文件标识]
     *  @param fileid
     */
    public void setFileid(String fileid){
        if(StringUtils.isEmpty(fileid))
            fileid=null;
        this.fileid = fileid;
        this.set("fileiddirtyflag",true);
    }
     /**
     *    fileid :file_id
     *   当属性名称与代码名称不一致时，
     *   多发一套get属性名称方法给gridvo用
     */
    public String getFile_id(){
        return  fileid;
    }
     /**
     *    fileid :file_id
     *   关闭mp驼峰转换，当属性名称与代码名称不一致时，多发一套set用于值注入
     */
    public void setFile_id(String file_id){
        this.fileid=file_id;
    }
    /**
     *  获取属性值[文件标识]
     */
    public String getFileid(){
        return this.fileid;
    }
    /**
     *  重置属性值[文件标识]
     */
    public void resetFileid(){
        this.set("fileiddirtyflag",false);
        this.fileid = null;
    }
    /**
     *  设置属性值[文件名称]
     *  @param filename
     */
    public void setFilename(String filename){
        if(StringUtils.isEmpty(filename))
            filename=null;
        this.filename = filename;
        this.set("filenamedirtyflag",true);
    }
     /**
     *    filename :file_name
     *   当属性名称与代码名称不一致时，
     *   多发一套get属性名称方法给gridvo用
     */
    public String getFile_name(){
        return  filename;
    }
     /**
     *    filename :file_name
     *   关闭mp驼峰转换，当属性名称与代码名称不一致时，多发一套set用于值注入
     */
    public void setFile_name(String file_name){
        this.filename=file_name;
    }
    /**
     *  获取属性值[文件名称]
     */
    public String getFilename(){
        return this.filename;
    }
    /**
     *  重置属性值[文件名称]
     */
    public void resetFilename(){
        this.set("filenamedirtyflag",false);
        this.filename = null;
    }
    /**
     *  设置属性值[指定目录]
     *  @param folder
     */
    public void setFolder(String folder){
        if(StringUtils.isEmpty(folder))
            folder=null;
        this.folder = folder;
        this.set("folderdirtyflag",true);
    }
    /**
     *  获取属性值[指定目录]
     */
    public String getFolder(){
        return this.folder;
    }
    /**
     *  重置属性值[指定目录]
     */
    public void resetFolder(){
        this.set("folderdirtyflag",false);
        this.folder = null;
    }
    /**
     *  设置属性值[存储路径]
     *  @param localpath
     */
    public void setLocalpath(String localpath){
        if(StringUtils.isEmpty(localpath))
            localpath=null;
        this.localpath = localpath;
        this.set("localpathdirtyflag",true);
    }
    /**
     *  获取属性值[存储路径]
     */
    public String getLocalpath(){
        return this.localpath;
    }
    /**
     *  重置属性值[存储路径]
     */
    public void resetLocalpath(){
        this.set("localpathdirtyflag",false);
        this.localpath = null;
    }
    /**
     *  设置属性值[存储路径2]
     *  @param localpath2
     */
    public void setLocalpath2(String localpath2){
        if(StringUtils.isEmpty(localpath2))
            localpath2=null;
        this.localpath2 = localpath2;
        this.set("localpath2dirtyflag",true);
    }
    /**
     *  获取属性值[存储路径2]
     */
    public String getLocalpath2(){
        return this.localpath2;
    }
    /**
     *  重置属性值[存储路径2]
     */
    public void resetLocalpath2(){
        this.set("localpath2dirtyflag",false);
        this.localpath2 = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[所有者标识]
     *  @param ownerid
     */
    public void setOwnerid(String ownerid){
        if(StringUtils.isEmpty(ownerid))
            ownerid=null;
        this.ownerid = ownerid;
        this.set("owneriddirtyflag",true);
    }
    /**
     *  获取属性值[所有者标识]
     */
    public String getOwnerid(){
        return this.ownerid;
    }
    /**
     *  重置属性值[所有者标识]
     */
    public void resetOwnerid(){
        this.set("owneriddirtyflag",false);
        this.ownerid = null;
    }
    /**
     *  设置属性值[所有者类型]
     *  @param ownertype
     */
    public void setOwnertype(String ownertype){
        if(StringUtils.isEmpty(ownertype))
            ownertype=null;
        this.ownertype = ownertype;
        this.set("ownertypedirtyflag",true);
    }
    /**
     *  获取属性值[所有者类型]
     */
    public String getOwnertype(){
        return this.ownertype;
    }
    /**
     *  重置属性值[所有者类型]
     */
    public void resetOwnertype(){
        this.set("ownertypedirtyflag",false);
        this.ownertype = null;
    }
    /**
     *  设置属性值[图片高度]
     *  @param picheight
     */
    public void setPicheight(Integer picheight){
        this.picheight = picheight;
        this.set("picheightdirtyflag",true);
    }
    /**
     *  获取属性值[图片高度]
     */
    public Integer getPicheight(){
        return this.picheight;
    }
    /**
     *  重置属性值[图片高度]
     */
    public void resetPicheight(){
        this.set("picheightdirtyflag",false);
        this.picheight = null;
    }
    /**
     *  设置属性值[图片宽度]
     *  @param picwidth
     */
    public void setPicwidth(Integer picwidth){
        this.picwidth = picwidth;
        this.set("picwidthdirtyflag",true);
    }
    /**
     *  获取属性值[图片宽度]
     */
    public Integer getPicwidth(){
        return this.picwidth;
    }
    /**
     *  重置属性值[图片宽度]
     */
    public void resetPicwidth(){
        this.set("picwidthdirtyflag",false);
        this.picwidth = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetDigestcode();
        resetEnable();
        resetFilename2();
        resetFilesize();
        resetFileid();
        resetFilename();
        resetFolder();
        resetLocalpath();
        resetLocalpath2();
        resetMemo();
        resetOwnerid();
        resetOwnertype();
        resetPicheight();
        resetPicwidth();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public File copyTo(File targetEntity)
	{
		BeanCopier copier=BeanCopier.create(File.class, File.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetFileid();
		return targetEntity;
	}
}